de.dhbwstuttgart.typeinference

## Class OderConstraint

- java.lang.Object
- - de.dhbwstuttgart.typeinference.constraints.OderMenge<Pair>
  - - de.dhbwstuttgart.typeinference.constraints.OderConstraint

- All Implemented Interfaces:
    KomplexeMenge<Pair>

      public class OderConstraint
      extends OderMenge<Pair>

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static Logger` | `logger`

    - ### Fields inherited from class de.dhbwstuttgart.typeinference.OderMenge

      `set`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OderConstraint()`
    `OderConstraint(ConstraintType p1, ConstraintType p2)` Erstellt ein neues Oder Constraint und fÃ¼gt bereits ein Constraint hinzu.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addConstraint(ConstraintPair toAdd)` Falls die Type des toAdd-Pairs nicht vom Typ RefType bzw.
    `void` | `addConstraint(ConstraintType p1, ConstraintType p2)` FÃ¼gt ein Pair(p1, p2) dem Constraint hinzu
    `void` | `addConstraint(UndConstraint methodConstraint)`
    `(package private) UndConstraint` | `filterUndConstraints()`
    `(package private) void` | `filterWrongConstraints(Unifier unifier)`

    - ### Methods inherited from class de.dhbwstuttgart.typeinference.OderMenge

      `addItem, addItems, cartesianProduct, getAndSets, getItems, getOrSets`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          private static final Logger logger

  - ### Constructor Detail

    - #### OderConstraint

          public OderConstraint(ConstraintType p1,
                                ConstraintType p2)

      Erstellt ein neues Oder Constraint und fÃ¼gt bereits ein Constraint hinzu.
      Parameters:
        `p1` -
        `p2` -

    - #### OderConstraint

          public OderConstraint()

  - ### Method Detail

    - #### addConstraint

          public void addConstraint(ConstraintType p1,
                                    ConstraintType p2)

      FÃ¼gt ein Pair(p1, p2) dem Constraint hinzu
      Parameters:
        `p1` -
        `p2` -

    - #### addConstraint

          public void addConstraint(ConstraintPair toAdd)

      Falls die Type des toAdd-Pairs nicht vom Typ RefType bzw. TypePlaceholder sind, so werden sie in einen RefType umgewandelt.
      Parameters:
        `toAdd` -

    - #### addConstraint

          public void addConstraint(UndConstraint methodConstraint)

    - #### filterWrongConstraints

          void filterWrongConstraints(Unifier unifier)

    - #### filterUndConstraints

          UndConstraint filterUndConstraints()